/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;
import android.util.Log;

import net.micode.notes.tool.GTaskStringUtils;

import org.json.JSONException;
import org.json.JSONObject;

//元数据类，处理与GTask相关的元数据信息
public class MetaData extends Task {
    //日志标签
    private final static String TAG = MetaData.class.getSimpleName();
    private String mRelatedGid = null;
    //设置元数据信息
    public void setMeta(String gid, JSONObject metaInfo) {
        try {
            //将关联的GTask ID放入元信息JSON对象
            metaInfo.put(GTaskStringUtils.META_HEAD_GTASK_ID, gid);
        } catch (JSONException e) {
            //记录错误日志
            Log.e(TAG, "failed to put related gid");
        }
        //设置标签内容及名称
        setNotes(metaInfo.toString());
        setName(GTaskStringUtils.META_NOTE_NAME);
    }
//获取关联的GTask ID
    public String getRelatedGid() {
        return mRelatedGid;
    }
//检查是否需要保存
    @Override
    public boolean isWorthSaving() {
        return getNotes() != null;
    }
//从远程JSON数据设置内容
    @Override
    public void setContentByRemoteJSON(JSONObject js) {
        super.setContentByRemoteJSON(js);
        if (getNotes() != null) {
            try {
                JSONObject metaInfo = new JSONObject(getNotes().trim());
                mRelatedGid = metaInfo.getString(GTaskStringUtils.META_HEAD_GTASK_ID);
            } catch (JSONException e) {
                //设置警告日志
                Log.w(TAG, "failed to get related gid");
                mRelatedGid = null;
            }
        }
    }
//从本地JSON设置内容
    @Override
    public void setContentByLocalJSON(JSONObject js) {
        // 此方法不应被调用
        throw new IllegalAccessError("MetaData:setContentByLocalJSON should not be called");
    }
//从内容获取本地JSON
    @Override
    public JSONObject getLocalJSONFromContent() {
        throw new IllegalAccessError("MetaData:getLocalJSONFromContent should not be called");
    }
//获取同步工作
    @Override
    public int getSyncAction(Cursor c) {
        throw new IllegalAccessError("MetaData:getSyncAction should not be called");
    }

}
